# eric7.DebugClients.Python.FlexCompleter

Word completion for the eric shell.

#### NOTE for eric variant

This version is a re-implementation of rlcompleter as found in the Python3 library. It is modified to work with the eric debug clients.

#### Original rlcompleter documentation

This requires the latest extension to the readline module. The completer completes keywords, built-ins and globals in a selectable namespace (which defaults to __main__); when completing NAME.NAME..., it evaluates (!) the expression up to the last dot and completes its attributes.

It's very cool to do "import sys" type "sys.", hit the completion key (twice), and see the list of names defined by the sys module!

Tip: to use the tab key as the completion key, call

readline.parse_and_bind("tab: complete")

Notes:

- Exceptions raised by the completer function are *ignored* (and generally cause the completion to fail). This is a feature -- since readline sets the tty device in raw (or cbreak) mode, printing a traceback wouldn't work well without some complicated hoopla to save, reset and restore the tty state.
- The evaluation of the NAME.NAME... form may cause arbitrary application defined code to be executed if an object with a __getattr__ hook is found. Since it is the responsibility of the application (or the user) to enable this feature, I consider this an acceptable risk. More complicated expressions (e.g. function calls or indexing operations) are *not* evaluated.
- When the original stdin is not a tty device, GNU readline is never used, and this module (and the readline module) are silently inactive.

### Global Attributes

__all__

### Classes

Completer | Class implementing the command line completer object.

### Functions

get_class_members | Module function to retrieve the class members.

## Completer

Class implementing the command line completer object.

### Derived from

None

### Class Attributes

None

### Class Methods

None

### Methods

Completer | Constructor
_callable_postfix | Protected method to check for a callable.
attr_matches | Public method to compute matches when text contains a dot.
complete | Public method to return the next possible completion for 'text'.
global_matches | Public method to compute matches when text is a simple name.

### Static Methods

None

#### Completer (Constructor)

Completer(namespace=None)

Constructor

Completer([namespace]) -> completer instance.

If unspecified, the default namespace where completions are performed is __main__ (technically, __main__.__dict__). Namespaces should be given as dictionaries.

Completer instances should be used as the completion mechanism of readline via the set_completer() call:

readline.set_completer(Completer(my_namespace).complete)

namespace
  The namespace for the completer.

Raises TypeError:
  raised to indicate a wrong data structure of the namespace object

#### Completer._callable_postfix

_callable_postfix(val, word)

Protected method to check for a callable.

val
  value to check (object)
word
  word to ammend (string)

Return:
  ammended word (string)

#### Completer.attr_matches

attr_matches(text)

Public method to compute matches when text contains a dot.

Assuming the text is of the form NAME.NAME....[NAME], and is evaluatable in self.namespace, it will be evaluated and its attributes (as revealed by dir()) are used as possible completions. (For class instances, class members are are also considered.)

WARNING: this can still invoke arbitrary C code, if an object with a __getattr__ hook is evaluated.

text
  The text to be completed. (string)

Return:
  A list of all matches.

#### Completer.complete

complete(text, state)

Public method to return the next possible completion for 'text'.

This is called successively with state == 0, 1, 2, ... until it returns None. The completion should begin with 'text'.

text
  The text to be completed. (string)
state
  The state of the completion. (integer)

Return:
  The possible completions as a list of strings.

#### Completer.global_matches

global_matches(text)

Public method to compute matches when text is a simple name.

text
  The text to be completed. (string)

Return:
  A list of all keywords, built-in functions and names currently defined in self.namespace that match.

Up

## get_class_members

get_class_members(klass)

Module function to retrieve the class members.

klass
  The class object to be analysed.

Return:
  A list of all names defined in the class.

Up